package com.winhc.task;

import com.alibaba.hologres.client.exception.HoloClientException;
import com.winhc.task.bean.JobArgs;
import com.winhc.task.common.SummaryArgs;
import com.winhc.task.job.CalcSummaryJob;
import com.winhc.task.util.DateUtils;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.io.IOException;
import java.util.*;
import java.util.stream.Collectors;


@SpringBootTest
@Slf4j
public class DataWorksSummaryJob {

    @Autowired
    CalcSummaryJob calcSummaryJob;

    @Test
    public void start() throws HoloClientException, IOException {

        //是否同步数据
        Boolean synData = true;
        //synData = false;
        //过滤集合(集合为空跑全量)
        //List<String> filter = Arrays.asList("company_holder", "company_staff", "company_change");
        List<String> filter = new ArrayList<>();

        //确定重跑集合(集合为空跑全量)

        List<String> add = Arrays.asList("company_punishment_info");

        List<String> list = SummaryArgs.SUMMARY_ARGS.keySet().stream()
                .filter(x -> {
                    boolean b1 = !filter.contains(x);
                    boolean b2 = (add.contains(x) || add.isEmpty());
                    return b1 && b2;
                }).distinct().collect(Collectors.toList());

        String project = "winhc_ng";
        String flow = "syn_summary";
        String taskName = "summary_v9";
        String nodeId = "700005089066";
        String holoTable = "test_tmp_xf_sum_v9";
        String targetIndexPre = "ng_rt_summary";
        String targetIndexSuf = DateUtils.getYesterday_ymd();

        //初始参数
        JobArgs jobArgs = JobArgs.builder()
                .project(project)
                .flow(flow)
                .taskName(taskName)
                .nodeId(nodeId)
                .holoTable(holoTable)
                .targetIndexPrefix(targetIndexPre)
                .targetIndexSuffix(targetIndexSuf)
                .build();
        calcSummaryJob.start(list, jobArgs, synData);
    }

    @Test
    public void start2() throws HoloClientException, IOException {
        List<String> list = new ArrayList<>(SummaryArgs.SUMMARY_ARGS.keySet());
        list.forEach(System.out::println);
    }

}